--[[
******************************
GuildnameGenerator 0.3
$Date: 2009-02-02 03:35:56 +0000 (Mon, 02 Feb 2009) $
$Rev: 26 $

Author: Armagon on Aggramar-EU
******************************
]]
local LastOne = "";
local Color = {};
Color["main"] = "cffffff66";
Color["help"] = "cffeeeeee";

function GetRandom(key)
	local GT = GNGText[key];
	
    ArraySize = table.getn(GT);
    RandomIndex = math.random(ArraySize);   
    SelectedPart = GT[RandomIndex];
    return SelectedPart;
end

function LocalChatMessage(message)
    if(DEFAULT_CHAT_FRAME) then DEFAULT_CHAT_FRAME:AddMessage(message);
    end
end

function Create()
    local Output = "";
    local Out    = {};
    local tmp1   = "";
    local tmp2   = "";
    
    -- decide which parts of the names are used at all
    local ifPre  = math.random(2);
    local ifAdj  = math.random(1);
    local ifAdj2 = math.random(3);
    local ifEnd  = math.random(2);
    local ifEnd2 = math.random(2);
    
    -- Pre - 33%
    if (ifPre  == 2) then 
        tinsert(Out, GetRandom("Pre"));
    end
    -- Adj - 50%
    if (ifAdj  == 1) then 
        tmp1 = GetRandom("Adj");
        tinsert(Out, tmp1);
    end   
    -- 2nd Adj - 33%
    if (ifAdj2 == 3) then
        tmp2 = GetRandom("Adj");
        while tmp2 == tmp1 do
            tmp2 = GetRandom("Adj");
        end
        tinsert(Out, tmp2);
    end
    -- Noun - 100%
    tinsert(Out, GetRandom("Noun"));
    -- End - 66%
    if (ifEnd > 0) then
	    tmp1 = GetRandom("End");
        tinsert(Out, "of");
        tinsert(Out, tmp1);
        -- 2nd End - 33%
        if (ifEnd2 == 2) then
            tmp2 = GetRandom("End");
            tinsert(Out, "and");
            while tmp2 == tmp1 do
                tmp2 = GetRandom("End");
            end
            tinsert(Out, tmp2);
        end
    end
    -- put it all together
    for k,v in pairs(Out) do
        Output = Output..Out[k].." ";
    end
    
    -- little fix to replace <Servername> with the current server
    local realm = GetRealmName();
    Output = string.gsub(Output, "<Servername>", realm);
    
    return Output;
end


function Main(param1)
    local p1 = string.lower(param1);
    --local p2 = string.lower(param2);
       
    -- parse command arguments
    if (p1 == "help") then 
        GNGHelpDisplay();
    elseif (p1 == "last") then
        --if (string.lower(param2) == "g") then
            SendChatMessage(LastOne, "GUILD");
        --[[elseif (string.lower(param2) == "p") then
            SendChatMessage(LastOne, "PARTY");
        else
            LocalChatMessage("|cffff6666"..LastOne);
        end]]
    else
        Output = Create();
        if (p1 == "g") then
	        SendChatMessage(Output, "GUILD");
        elseif (p1 == "p") then
            SendChatMessage(Output,"PARTY");
        else
            LocalChatMessage("|"..Color["main"]..Output);
        end
        LastOne = Output;
    end    
end

function GNGHelpDisplay() 
    LocalChatMessage("|"..Color["main"].." GuildnameGenerator Usage:");
    LocalChatMessage("|"..Color["help"].."   /gng      (Sends to Self)");
    LocalChatMessage("|"..Color["help"].."   /gng p    (Sends to Party)");
    LocalChatMessage("|"..Color["help"].."   /gng g    (Sends to Guild)");
    LocalChatMessage("|"..Color["help"].."   /gng last (Sends last one)");
end

SLASH_gng1 = "/gng";
SlashCmdList["gng"] = Main;